diff --git a/src/gui/painting/qdrawhelper.cpp b/src/gui/painting/qdrawhelper.cpp
index e46e997..76a5dfb 100644
--- a/src/gui/painting/qdrawhelper.cpp
+++ b/src/gui/painting/qdrawhelper.cpp
@@ -185,7 +185,7 @@ static const uint *QT_FASTCALL convertToRGB32(uint *buffer, const uint *src, int
 }
 
 template<QImage::Format Format>
-static const QRgba64 *QT_FASTCALL convertToRGB64(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertToRGB64(QRgba64 *buffer, const quint64 *src, int count,
                                                  const QPixelLayout *, const QRgb *)
 {
     Q_CONSTEXPR uint redMask = ((1 << redWidth<Format>()) - 1);
@@ -250,7 +250,7 @@ static const uint *QT_FASTCALL convertARGBPMToARGB32PM(uint *buffer, const uint
 }
 
 template<QImage::Format Format>
-static const QRgba64 *QT_FASTCALL convertARGBPMToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertARGBPMToRGBA64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                           const QPixelLayout *, const QRgb *)
 {
     Q_CONSTEXPR uint alphaMask = ((1 << alphaWidth<Format>()) - 1);
@@ -402,7 +402,7 @@ template<QImage::Format Format> Q_DECL_CONSTEXPR static inline QPixelLayout pixe
         convertARGBPMToARGB32PM<Format>,
         convertARGBPMFromARGB32PM<Format>,
         convertARGBPMFromRGB32<Format>,
-        convertARGBPMToARGB64PM<Format>
+        convertARGBPMToRGBA64PM<Format>
     };
 }
 
@@ -417,7 +417,7 @@ static const uint *QT_FASTCALL convertIndexedToARGB32PM(uint *buffer, const uint
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertIndexedToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertIndexedToARGB64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                            const QPixelLayout *, const QRgb *clut)
 {
     for (int i = 0; i < count; ++i)
@@ -467,7 +467,7 @@ static const uint *QT_FASTCALL convertGrayscale8ToRGB32(uint *buffer, const uint
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertAlpha8ToRGB64(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertAlpha8ToRGB64(QRgba64 *buffer, const quint64 *src, int count,
                                                        const QPixelLayout *, const QRgb *)
 {
     for (int i = 0; i < count; ++i)
@@ -475,7 +475,7 @@ static const QRgba64 *QT_FASTCALL convertAlpha8ToRGB64(QRgba64 *buffer, const ui
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertGrayscale8ToRGB64(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertGrayscale8ToRGB64(QRgba64 *buffer, const quint64 *src, int count,
                                                            const QPixelLayout *, const QRgb *)
 {
     for (int i = 0; i < count; ++i)
@@ -501,7 +501,7 @@ static const uint *QT_FASTCALL convertRGBA8888PMFromARGB32PM(uint *buffer, const
 
 #ifdef __SSE2__
 template<bool RGBA, bool maskAlpha>
-static inline void qConvertARGB32PMToARGB64PM_sse2(QRgba64 *buffer, const uint *src, int count)
+static inline void qConvertARGB32PMToRGBA64PM_sse2(QRgba64 *buffer, const quint64 *src, int count)
 {
     const __m128i amask = _mm_set1_epi32(0xff000000);
     int i = 0;
@@ -513,7 +513,9 @@ static inline void qConvertARGB32PMToARGB64PM_sse2(QRgba64 *buffer, const uint *
         i++;
     }
     for (; i < count-3; i += 4) {
-        __m128i vs = _mm_loadu_si128((const __m128i*)src);
+        __m128 vs1 = _mm_loadu_ps((const float*)src);
+        __m128 vs2 = _mm_loadu_ps((const float*)(src + 2));
+        __m128i vs = _mm_castps_si128(_mm_shuffle_ps(vs1, vs2, _MM_SHUFFLE(2, 0, 2, 0)));
         if (maskAlpha)
             vs = _mm_or_si128(vs, amask);
         src += 4;
@@ -540,11 +542,11 @@ static inline void qConvertARGB32PMToARGB64PM_sse2(QRgba64 *buffer, const uint *
 }
 #endif
 
-static const QRgba64 *QT_FASTCALL convertRGB32ToRGB64(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertRGB32ToRGB64(QRgba64 *buffer, const quint64 *src, int count,
                                                       const QPixelLayout *, const QRgb *)
 {
 #ifdef __SSE2__
-    qConvertARGB32PMToARGB64PM_sse2<false, true>(buffer, src, count);
+    qConvertARGB32PMToRGBA64PM_sse2<false, true>(buffer, src, count);
 #else
     for (int i = 0; i < count; ++i)
         buffer[i] = QRgba64::fromArgb32(0xff000000 | src[i]);
@@ -552,11 +554,17 @@ static const QRgba64 *QT_FASTCALL convertRGB32ToRGB64(QRgba64 *buffer, const uin
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertARGB32ToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertRGB64ToRGB64(QRgba64 *, const quint64 *src, int,
+                                                      const QPixelLayout *, const QRgb *)
+{
+    return reinterpret_cast<const QRgba64*>(src);
+}
+
+static const QRgba64 *QT_FASTCALL convertARGB32ToRGBA64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                           const QPixelLayout *, const QRgb *)
 {
 #ifdef __SSE2__
-    qConvertARGB32PMToARGB64PM_sse2<false, false>(buffer, src, count);
+    qConvertARGB32PMToRGBA64PM_sse2<false, false>(buffer, src, count);
     for (int i = 0; i < count; ++i)
         buffer[i] = buffer[i].premultiplied();
 #else
@@ -566,11 +574,19 @@ static const QRgba64 *QT_FASTCALL convertARGB32ToARGB64PM(QRgba64 *buffer, const
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertARGB32PMToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertRGBA64ToRGBA64PM(QRgba64 *buffer, const quint64 *src, int count,
+                                                          const QPixelLayout *, const QRgb *)
+{
+    for (int i = 0; i < count; ++i)
+        buffer[i] = QRgba64::fromRgba64(src[i]).premultiplied();
+    return buffer;
+}
+
+static const QRgba64 *QT_FASTCALL convertARGB32PMToRGBA64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                             const QPixelLayout *, const QRgb *)
 {
 #ifdef __SSE2__
-    qConvertARGB32PMToARGB64PM_sse2<false, false>(buffer, src, count);
+    qConvertARGB32PMToRGBA64PM_sse2<false, false>(buffer, src, count);
 #else
     for (int i = 0; i < count; ++i)
         buffer[i] = QRgba64::fromArgb32(src[i]);
@@ -578,11 +594,11 @@ static const QRgba64 *QT_FASTCALL convertARGB32PMToARGB64PM(QRgba64 *buffer, con
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertRGBA8888ToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertRGBA8888ToRGBA64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                             const QPixelLayout *, const QRgb *)
 {
 #ifdef __SSE2__
-    qConvertARGB32PMToARGB64PM_sse2<true, false>(buffer, src, count);
+    qConvertARGB32PMToRGBA64PM_sse2<true, false>(buffer, src, count);
     for (int i = 0; i < count; ++i)
         buffer[i] = buffer[i].premultiplied();
 #else
@@ -592,11 +608,11 @@ static const QRgba64 *QT_FASTCALL convertRGBA8888ToARGB64PM(QRgba64 *buffer, con
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertRGBA8888PMToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertRGBA8888PMToRGBA64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                              const QPixelLayout *, const QRgb *)
 {
 #ifdef __SSE2__
-    qConvertARGB32PMToARGB64PM_sse2<true, false>(buffer, src, count);
+    qConvertARGB32PMToRGBA64PM_sse2<true, false>(buffer, src, count);
 #else
     for (int i = 0; i < count; ++i)
         buffer[i] = QRgba64::fromArgb32(RGBA2ARGB(src[i]));
@@ -639,7 +655,7 @@ static const uint *QT_FASTCALL convertA2RGB30PMToARGB32PM(uint *buffer, const ui
 
 #ifdef __SSE2__
 template<QtPixelOrder PixelOrder>
-static inline void qConvertA2RGB30PMToARGB64PM_sse2(QRgba64 *buffer, const uint *src, int count)
+static inline void qConvertA2RGB30PMToARGB64PM_sse2(QRgba64 *buffer, const quint64 *src, int count)
 {
     const __m128i rmask = _mm_set1_epi32(0x3ff00000);
     const __m128i gmask = _mm_set1_epi32(0x000ffc00);
@@ -651,7 +667,9 @@ static inline void qConvertA2RGB30PMToARGB64PM_sse2(QRgba64 *buffer, const uint
         i++;
     }
     for (; i < count-3; i += 4) {
-        __m128i vs = _mm_loadu_si128((const __m128i*)src);
+        __m128 vs1 = _mm_loadu_ps((const float*)src);
+        __m128 vs2 = _mm_loadu_ps((const float*)(src + 2));
+        __m128i vs = _mm_castps_si128(_mm_shuffle_ps(vs1, vs2, _MM_SHUFFLE(2, 0, 2, 0)));
         src += 4;
         __m128i va = _mm_srli_epi32(vs, 30);
         __m128i vr = _mm_and_si128(vs, rmask);
@@ -679,7 +697,7 @@ static inline void qConvertA2RGB30PMToARGB64PM_sse2(QRgba64 *buffer, const uint
 #endif
 
 template<QtPixelOrder PixelOrder>
-static const QRgba64 *QT_FASTCALL convertA2RGB30PMToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertA2RGB30PMToARGB64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                              const QPixelLayout *, const QRgb *)
 {
 #ifdef __SSE2__
@@ -781,6 +799,33 @@ inline uint QT_FASTCALL fetchPixel<QPixelLayout::BPP32>(const uchar *src, int in
     return reinterpret_cast<const uint *>(src)[index];
 }
 
+template <>
+inline uint QT_FASTCALL fetchPixel<QPixelLayout::BPP64>(const uchar *src, int index)
+{
+    // We have to do the conversion in fetch to fit into a 32bit uint
+    QRgba64 c = reinterpret_cast<const QRgba64 *>(src)[index];
+    return c.toArgb32();
+}
+
+template <QPixelLayout::BPP bpp>
+static quint64 QT_FASTCALL fetchPixel64(const uchar *src, int index)
+{
+    return fetchPixel<bpp>(src, index);
+}
+
+template <>
+quint64 QT_FASTCALL fetchPixel64<QPixelLayout::BPP64>(const uchar *src, int index)
+{
+    return reinterpret_cast<const quint64 *>(src)[index];
+}
+
+template <>
+quint64 QT_FASTCALL fetchPixel64<QPixelLayout::BPPNone>(const uchar *, int)
+{
+    Q_UNREACHABLE();
+    return 0;
+}
+
 template <QPixelLayout::BPP bpp>
 inline const uint *QT_FASTCALL fetchPixels(uint *buffer, const uchar *src, int index, int count)
 {
@@ -795,11 +840,71 @@ inline const uint *QT_FASTCALL fetchPixels<QPixelLayout::BPP32>(uint *, const uc
     return reinterpret_cast<const uint *>(src) + index;
 }
 
-template <QPixelLayout::BPP width> static
+template<bool RGBA>
+void qt_convertRGBA64ToARGB32(uint *dst, const QRgba64 *src, int count)
+{
+    int i = 0;
+#ifdef __SSE2__
+    if (((uintptr_t)dst & 0x7) && count > 0) {
+        *dst++ = (*src++).toArgb32();
+        i++;
+    }
+    const __m128i vhalf = _mm_set1_epi32(0x80);
+    const __m128i vzero = _mm_setzero_si128();
+    for (; i < count-1; i += 2) {
+        __m128i vs = _mm_loadu_si128((const __m128i*)src);
+        src += 2;
+        if (!RGBA) {
+            vs = _mm_shufflelo_epi16(vs, _MM_SHUFFLE(3, 0, 1, 2));
+            vs = _mm_shufflehi_epi16(vs, _MM_SHUFFLE(3, 0, 1, 2));
+        }
+        __m128i v1 = _mm_unpacklo_epi16(vs, vzero);
+        __m128i v2 = _mm_unpackhi_epi16(vs, vzero);
+        v1 = _mm_add_epi32(v1, vhalf);
+        v2 = _mm_add_epi32(v2, vhalf);
+        v1 = _mm_sub_epi32(v1, _mm_srli_epi32(v1, 8));
+        v2 = _mm_sub_epi32(v2, _mm_srli_epi32(v2, 8));
+        v1 = _mm_srli_epi32(v1, 8);
+        v2 = _mm_srli_epi32(v2, 8);
+        v1 = _mm_packs_epi32(v1, v2);
+        v1 = _mm_packus_epi16(v1, vzero);
+        _mm_storel_epi64((__m128i*)(dst), v1);
+        dst += 2;
+    }
+#endif
+    for (; i < count; i++)
+        *dst++ = (*src++).toArgb32();
+}
+template void qt_convertRGBA64ToARGB32<false>(uint *dst, const QRgba64 *src, int count);
+template void qt_convertRGBA64ToARGB32<true>(uint *dst, const QRgba64 *src, int count);
+
+template <>
+inline const uint *QT_FASTCALL fetchPixels<QPixelLayout::BPP64>(uint *buffer, const uchar *src, int index, int count)
+{
+    const QRgba64 *s = reinterpret_cast<const QRgba64 *>(src) + index;
+    qt_convertRGBA64ToARGB32<false>(buffer, s, count);
+    return buffer;
+}
+
+template <QPixelLayout::BPP bpp>
+const quint64 *QT_FASTCALL fetchPixels64(quint64 *buffer, const uchar *src, int index, int count)
+{
+    for (int i = 0; i < count; ++i)
+        buffer[i] = fetchPixel64<bpp>(src, index + i);
+    return buffer;
+}
+
+template <>
+const quint64 *QT_FASTCALL fetchPixels64<QPixelLayout::BPP64>(quint64 *, const uchar *src, int index, int)
+{
+    return reinterpret_cast<const quint64 *>(src) + index;
+}
+
+template <QPixelLayout::BPP width>
 void QT_FASTCALL storePixel(uchar *dest, int index, uint pixel);
 
 template <>
-inline void QT_FASTCALL storePixel<QPixelLayout::BPP1LSB>(uchar *dest, int index, uint pixel)
+void QT_FASTCALL storePixel<QPixelLayout::BPP1LSB>(uchar *dest, int index, uint pixel)
 {
     if (pixel)
         dest[index >> 3] |= 1 << (index & 7);
@@ -808,7 +913,7 @@ inline void QT_FASTCALL storePixel<QPixelLayout::BPP1LSB>(uchar *dest, int index
 }
 
 template <>
-inline void QT_FASTCALL storePixel<QPixelLayout::BPP1MSB>(uchar *dest, int index, uint pixel)
+void QT_FASTCALL storePixel<QPixelLayout::BPP1MSB>(uchar *dest, int index, uint pixel)
 {
     if (pixel)
         dest[index >> 3] |= 1 << (~index & 7);
@@ -817,23 +922,42 @@ inline void QT_FASTCALL storePixel<QPixelLayout::BPP1MSB>(uchar *dest, int index
 }
 
 template <>
-inline void QT_FASTCALL storePixel<QPixelLayout::BPP8>(uchar *dest, int index, uint pixel)
+void QT_FASTCALL storePixel<QPixelLayout::BPP8>(uchar *dest, int index, uint pixel)
 {
     dest[index] = uchar(pixel);
 }
 
 template <>
-inline void QT_FASTCALL storePixel<QPixelLayout::BPP16>(uchar *dest, int index, uint pixel)
+void QT_FASTCALL storePixel<QPixelLayout::BPP16>(uchar *dest, int index, uint pixel)
 {
     reinterpret_cast<quint16 *>(dest)[index] = quint16(pixel);
 }
 
 template <>
-inline void QT_FASTCALL storePixel<QPixelLayout::BPP24>(uchar *dest, int index, uint pixel)
+void QT_FASTCALL storePixel<QPixelLayout::BPP24>(uchar *dest, int index, uint pixel)
 {
     reinterpret_cast<quint24 *>(dest)[index] = quint24(pixel);
 }
 
+template <>
+void QT_FASTCALL storePixel<QPixelLayout::BPP32>(uchar *dest, int index, uint pixel)
+{
+    reinterpret_cast<uint *>(dest)[index] = pixel;
+}
+
+template <>
+void QT_FASTCALL storePixel<QPixelLayout::BPP64>(uchar *dest, int index, uint pixel)
+{
+    QRgba64 p = QRgba64::fromArgb32(pixel);
+    reinterpret_cast<quint64 *>(dest)[index] = p;
+}
+
+template <QPixelLayout::BPP width>
+static void QT_FASTCALL storePixel64(uchar *dest, int index, quint64 pixel)
+{
+    storePixel<width>(dest, index, pixel);
+}
+
 template <QPixelLayout::BPP width>
 inline void QT_FASTCALL storePixels(uchar *dest, const uint *src, int index, int count)
 {
@@ -847,6 +971,19 @@ inline void QT_FASTCALL storePixels<QPixelLayout::BPP32>(uchar *dest, const uint
     memcpy(reinterpret_cast<uint *>(dest) + index, src, count * sizeof(uint));
 }
 
+template <QPixelLayout::BPP width>
+static void QT_FASTCALL storePixels64(uchar *dest, const quint64 *src, int index, int count)
+{
+    for (int i = 0; i < count; ++i)
+        storePixel64<width>(dest, index + i, src[i]);
+}
+
+template <>
+void QT_FASTCALL storePixels64<QPixelLayout::BPP64>(uchar *dest, const quint64 *src, int index, int count)
+{
+    memcpy(reinterpret_cast<quint64 *>(dest) + index, src, count * sizeof(quint64));
+}
+
 // Note:
 // convertToArgb32() assumes that no color channel is less than 4 bits.
 // convertFromArgb32() assumes that no color channel is more than 8 bits.
@@ -859,8 +996,8 @@ QPixelLayout qPixelLayouts[QImage::NImageFormats] = {
     // Technically using convertPassThrough to convert from ARGB32PM to RGB32 is wrong,
     // but everywhere this generic conversion would be wrong is currently overloaded.
     { 8, 16, 8,  8, 8,  0, 0,  0, false, QPixelLayout::BPP32, convertPassThrough, convertPassThrough, convertPassThrough, convertRGB32ToRGB64 }, // Format_RGB32
-    { 8, 16, 8,  8, 8,  0, 8, 24, false, QPixelLayout::BPP32, convertARGB32ToARGB32PM, convertARGB32FromARGB32PM, convertPassThrough, convertARGB32ToARGB64PM }, // Format_ARGB32
-    { 8, 16, 8,  8, 8,  0, 8, 24,  true, QPixelLayout::BPP32, convertPassThrough, convertPassThrough, convertPassThrough, convertARGB32PMToARGB64PM }, // Format_ARGB32_Premultiplied
+    { 8, 16, 8,  8, 8,  0, 8, 24, false, QPixelLayout::BPP32, convertARGB32ToARGB32PM, convertARGB32FromARGB32PM, convertPassThrough, convertARGB32ToRGBA64PM }, // Format_ARGB32
+    { 8, 16, 8,  8, 8,  0, 8, 24,  true, QPixelLayout::BPP32, convertPassThrough, convertPassThrough, convertPassThrough, convertARGB32PMToRGBA64PM }, // Format_ARGB32_Premultiplied
 #ifdef Q_COMPILER_CONSTEXPR
     pixelLayoutRGB<QImage::Format_RGB16>(),
     pixelLayoutARGBPM<QImage::Format_ARGB8565_Premultiplied>(),
@@ -882,7 +1019,7 @@ QPixelLayout qPixelLayouts[QImage::NImageFormats] = {
       convertARGBPMToARGB32PM<QImage::Format_ARGB8565_Premultiplied>,
       convertARGBPMFromARGB32PM<QImage::Format_ARGB8565_Premultiplied>,
       convertARGBPMFromRGB32<QImage::Format_ARGB8565_Premultiplied>,
-      convertARGBPMToARGB64PM<QImage::Format_ARGB8565_Premultiplied>,
+      convertARGBPMToRGBA64PM<QImage::Format_ARGB8565_Premultiplied>,
     },
     { 6, 12, 6,  6, 6,  0, 0,  0, false, QPixelLayout::BPP24,
       convertToRGB32<QImage::Format_RGB666>,
@@ -894,7 +1031,7 @@ QPixelLayout qPixelLayouts[QImage::NImageFormats] = {
       convertARGBPMToARGB32PM<QImage::Format_ARGB6666_Premultiplied>,
       convertARGBPMFromARGB32PM<QImage::Format_ARGB6666_Premultiplied>,
       convertARGBPMFromRGB32<QImage::Format_ARGB6666_Premultiplied>,
-      convertARGBPMToARGB64PM<QImage::Format_ARGB6666_Premultiplied>,
+      convertARGBPMToRGBA64PM<QImage::Format_ARGB6666_Premultiplied>,
     },
     { 5, 10, 5,  5, 5,  0, 0,  0, false, QPixelLayout::BPP16,
       convertToRGB32<QImage::Format_RGB555>,
@@ -906,7 +1043,7 @@ QPixelLayout qPixelLayouts[QImage::NImageFormats] = {
       convertARGBPMToARGB32PM<QImage::Format_ARGB8555_Premultiplied>,
       convertARGBPMFromARGB32PM<QImage::Format_ARGB8555_Premultiplied>,
       convertARGBPMFromRGB32<QImage::Format_ARGB8555_Premultiplied>,
-      convertARGBPMToARGB64PM<QImage::Format_ARGB8555_Premultiplied>,
+      convertARGBPMToRGBA64PM<QImage::Format_ARGB8555_Premultiplied>,
     },
     { 8, 16, 8,  8, 8,  0, 0,  0, false, QPixelLayout::BPP24,
       convertToRGB32<QImage::Format_RGB888>,
@@ -924,56 +1061,96 @@ QPixelLayout qPixelLayouts[QImage::NImageFormats] = {
       convertARGBPMToARGB32PM<QImage::Format_ARGB4444_Premultiplied>,
       convertARGBPMFromARGB32PM<QImage::Format_ARGB4444_Premultiplied>,
       convertARGBPMFromRGB32<QImage::Format_ARGB4444_Premultiplied>,
-      convertARGBPMToARGB64PM<QImage::Format_ARGB4444_Premultiplied>,
+      convertARGBPMToRGBA64PM<QImage::Format_ARGB4444_Premultiplied>,
     },
 #endif
 #if Q_BYTE_ORDER == Q_BIG_ENDIAN
-    { 8, 24, 8, 16, 8,  8, 0,  0, false, QPixelLayout::BPP32, convertRGBA8888PMToARGB32PM, convertRGBXFromARGB32PM, convertRGBXFromRGB32, convertRGBA8888PMToARGB64PM }, // Format_RGBX8888
-    { 8, 24, 8, 16, 8,  8, 8,  0, false, QPixelLayout::BPP32, convertRGBA8888ToARGB32PM, convertRGBA8888FromARGB32PM, convertRGBXFromRGB32, convertRGBA8888ToARGB64PM }, // Format_RGBA8888
-    { 8, 24, 8, 16, 8,  8, 8,  0,  true, QPixelLayout::BPP32, convertRGBA8888PMToARGB32PM, convertRGBA8888PMFromARGB32PM, convertRGBXFromRGB32, convertRGBA8888PMToARGB64PM}, // Format_RGBA8888_Premultiplied
+    { 8, 24, 8, 16, 8,  8, 0,  0, false, QPixelLayout::BPP32, convertRGBA8888PMToARGB32PM, convertRGBXFromARGB32PM, convertRGBXFromRGB32, convertRGBA8888PMToRGBA64PM }, // Format_RGBX8888
+    { 8, 24, 8, 16, 8,  8, 8,  0, false, QPixelLayout::BPP32, convertRGBA8888ToARGB32PM, convertRGBA8888FromARGB32PM, convertRGBXFromRGB32, convertRGBA8888ToRGBA64PM }, // Format_RGBA8888
+    { 8, 24, 8, 16, 8,  8, 8,  0,  true, QPixelLayout::BPP32, convertRGBA8888PMToARGB32PM, convertRGBA8888PMFromARGB32PM, convertRGBXFromRGB32, convertRGBA8888PMToRGBA64PM}, // Format_RGBA8888_Premultiplied
 #else
-    { 8,  0, 8,  8, 8, 16, 0, 24, false, QPixelLayout::BPP32, convertRGBA8888PMToARGB32PM, convertRGBXFromARGB32PM, convertRGBXFromRGB32, convertRGBA8888PMToARGB64PM }, // Format_RGBX8888
-    { 8,  0, 8,  8, 8, 16, 8, 24, false, QPixelLayout::BPP32, convertRGBA8888ToARGB32PM, convertRGBA8888FromARGB32PM, convertRGBXFromRGB32, convertRGBA8888ToARGB64PM }, // Format_RGBA8888 (ABGR32)
-    { 8,  0, 8,  8, 8, 16, 8, 24,  true, QPixelLayout::BPP32, convertRGBA8888PMToARGB32PM, convertRGBA8888PMFromARGB32PM, convertRGBXFromRGB32, convertRGBA8888PMToARGB64PM },  // Format_RGBA8888_Premultiplied
+    { 8,  0, 8,  8, 8, 16, 0, 24, false, QPixelLayout::BPP32, convertRGBA8888PMToARGB32PM, convertRGBXFromARGB32PM, convertRGBXFromRGB32, convertRGBA8888PMToRGBA64PM }, // Format_RGBX8888
+    { 8,  0, 8,  8, 8, 16, 8, 24, false, QPixelLayout::BPP32, convertRGBA8888ToARGB32PM, convertRGBA8888FromARGB32PM, convertRGBXFromRGB32, convertRGBA8888ToRGBA64PM }, // Format_RGBA8888 (ABGR32)
+    { 8,  0, 8,  8, 8, 16, 8, 24,  true, QPixelLayout::BPP32, convertRGBA8888PMToARGB32PM, convertRGBA8888PMFromARGB32PM, convertRGBXFromRGB32, convertRGBA8888PMToRGBA64PM },  // Format_RGBA8888_Premultiplied
 #endif
     { 10,  20, 10,  10, 10, 0, 0, 30, false, QPixelLayout::BPP32, convertA2RGB30PMToARGB32PM<PixelOrderBGR>, convertRGB30FromARGB32PM<PixelOrderBGR>, convertRGB30FromRGB32<PixelOrderBGR>, convertA2RGB30PMToARGB64PM<PixelOrderBGR> }, // Format_BGR30
     { 10,  20, 10,  10, 10, 0, 2, 30,  true, QPixelLayout::BPP32, convertA2RGB30PMToARGB32PM<PixelOrderBGR>, convertA2RGB30PMFromARGB32PM<PixelOrderBGR>, convertRGB30FromRGB32<PixelOrderBGR>, convertA2RGB30PMToARGB64PM<PixelOrderBGR> },  // Format_A2BGR30_Premultiplied
     { 10,  0, 10,  10, 10, 20, 0, 30, false, QPixelLayout::BPP32, convertA2RGB30PMToARGB32PM<PixelOrderRGB>, convertRGB30FromARGB32PM<PixelOrderRGB>, convertRGB30FromRGB32<PixelOrderRGB>, convertA2RGB30PMToARGB64PM<PixelOrderRGB> }, // Format_RGB30
     { 10,  0, 10,  10, 10, 20, 2, 30,  true, QPixelLayout::BPP32, convertA2RGB30PMToARGB32PM<PixelOrderRGB>, convertA2RGB30PMFromARGB32PM<PixelOrderRGB>, convertRGB30FromRGB32<PixelOrderRGB>, convertA2RGB30PMToARGB64PM<PixelOrderRGB> },  // Format_A2RGB30_Premultiplied
     { 0, 0,  0, 0,  0, 0,  8, 0, false, QPixelLayout::BPP8, convertAlpha8ToRGB32, convertAlpha8FromARGB32PM, 0, convertAlpha8ToRGB64 }, // Format_Alpha8
-    { 0, 0,  0, 0,  0, 0,  0, 0, false, QPixelLayout::BPP8, convertGrayscale8ToRGB32, convertGrayscale8FromARGB32PM, convertGrayscale8FromRGB32, convertGrayscale8ToRGB64 } // Format_Grayscale8
+    { 0, 0,  0, 0,  0, 0,  0, 0, false, QPixelLayout::BPP8, convertGrayscale8ToRGB32, convertGrayscale8FromARGB32PM, convertGrayscale8FromRGB32, convertGrayscale8ToRGB64 }, // Format_Grayscale8
+    // The BPP64 formats are converted on fetch and therefore like the (A)RGB32 after fetch.
+    { 8, 16, 8, 8, 8, 0, 0, 24, false, QPixelLayout::BPP64, convertPassThrough, convertPassThrough, convertPassThrough, convertRGB64ToRGB64 }, // Format_RGBX64
+    { 8, 16, 8, 8, 8, 0, 8, 24, false, QPixelLayout::BPP64, convertARGB32ToARGB32PM, convertARGB32FromARGB32PM, convertPassThrough, convertRGBA64ToRGBA64PM }, // Format_RGBA64
+    { 8, 16, 8, 8, 8, 0, 8, 24,  true, QPixelLayout::BPP64, convertPassThrough, convertPassThrough, convertPassThrough, convertRGB64ToRGB64 } // Format_RGB64_Premultiplied
+};
+
+const FetchPixelsFunc qFetchPixels[QPixelLayout::BPPCount] = {
+    0, // BPPNone
+    fetchPixels<QPixelLayout::BPP1MSB>,
+    fetchPixels<QPixelLayout::BPP1LSB>,
+    fetchPixels<QPixelLayout::BPP8>,
+    fetchPixels<QPixelLayout::BPP16>,
+    fetchPixels<QPixelLayout::BPP24>,
+    fetchPixels<QPixelLayout::BPP32>,
+    fetchPixels<QPixelLayout::BPP64>
 };
 
-FetchPixelsFunc qFetchPixels[QPixelLayout::BPPCount] = {
+const StorePixelsFunc qStorePixels[QPixelLayout::BPPCount] = {
     0, // BPPNone
-    fetchPixels<QPixelLayout::BPP1MSB>, // BPP1MSB
-    fetchPixels<QPixelLayout::BPP1LSB>, // BPP1LSB
-    fetchPixels<QPixelLayout::BPP8>, // BPP8
-    fetchPixels<QPixelLayout::BPP16>, // BPP16
-    fetchPixels<QPixelLayout::BPP24>, // BPP24
-    fetchPixels<QPixelLayout::BPP32> // BPP32
+    storePixels<QPixelLayout::BPP1MSB>,
+    storePixels<QPixelLayout::BPP1LSB>,
+    storePixels<QPixelLayout::BPP8>,
+    storePixels<QPixelLayout::BPP16>,
+    storePixels<QPixelLayout::BPP24>,
+    storePixels<QPixelLayout::BPP32>,
+    storePixels<QPixelLayout::BPP64>
 };
 
-StorePixelsFunc qStorePixels[QPixelLayout::BPPCount] = {
+const FetchPixelsFunc64 qFetchPixels64[QPixelLayout::BPPCount] = {
     0, // BPPNone
-    storePixels<QPixelLayout::BPP1MSB>, // BPP1MSB
-    storePixels<QPixelLayout::BPP1LSB>, // BPP1LSB
-    storePixels<QPixelLayout::BPP8>, // BPP8
-    storePixels<QPixelLayout::BPP16>, // BPP16
-    storePixels<QPixelLayout::BPP24>, // BPP24
-    storePixels<QPixelLayout::BPP32> // BPP32
+    fetchPixels64<QPixelLayout::BPP1MSB>,
+    fetchPixels64<QPixelLayout::BPP1LSB>,
+    fetchPixels64<QPixelLayout::BPP8>,
+    fetchPixels64<QPixelLayout::BPP16>,
+    fetchPixels64<QPixelLayout::BPP24>,
+    fetchPixels64<QPixelLayout::BPP32>,
+    fetchPixels64<QPixelLayout::BPP64>
+};
+
+const StorePixelsFunc64 qStorePixels64[QPixelLayout::BPPCount] = {
+    0, // BPPNone
+    storePixels64<QPixelLayout::BPP1MSB>,
+    storePixels64<QPixelLayout::BPP1LSB>,
+    storePixels64<QPixelLayout::BPP8>,
+    storePixels64<QPixelLayout::BPP16>,
+    storePixels64<QPixelLayout::BPP24>,
+    storePixels64<QPixelLayout::BPP64>
 };
 
 typedef uint (QT_FASTCALL *FetchPixelFunc)(const uchar *src, int index);
+typedef quint64 (QT_FASTCALL *FetchPixelFunc64)(const uchar *src, int index);
 
-FetchPixelFunc qFetchPixel[QPixelLayout::BPPCount] = {
+const FetchPixelFunc qFetchPixel[QPixelLayout::BPPCount] = {
     0, // BPPNone
-    fetchPixel<QPixelLayout::BPP1MSB>, // BPP1MSB
-    fetchPixel<QPixelLayout::BPP1LSB>, // BPP1LSB
-    fetchPixel<QPixelLayout::BPP8>, // BPP8
-    fetchPixel<QPixelLayout::BPP16>, // BPP16
-    fetchPixel<QPixelLayout::BPP24>, // BPP24
-    fetchPixel<QPixelLayout::BPP32> // BPP32
+    fetchPixel<QPixelLayout::BPP1MSB>,
+    fetchPixel<QPixelLayout::BPP1LSB>,
+    fetchPixel<QPixelLayout::BPP8>,
+    fetchPixel<QPixelLayout::BPP16>,
+    fetchPixel<QPixelLayout::BPP24>,
+    fetchPixel<QPixelLayout::BPP32>,
+    fetchPixel<QPixelLayout::BPP64>,
+};
+
+const FetchPixelFunc64 qFetchPixel64[QPixelLayout::BPPCount] = {
+    0, // BPPNone
+    fetchPixel64<QPixelLayout::BPP1MSB>,
+    fetchPixel64<QPixelLayout::BPP1LSB>,
+    fetchPixel64<QPixelLayout::BPP8>,
+    fetchPixel64<QPixelLayout::BPP16>,
+    fetchPixel64<QPixelLayout::BPP24>,
+    fetchPixel64<QPixelLayout::BPP32>,
+    fetchPixel64<QPixelLayout::BPP64>,
 };
 
 /*
@@ -1030,16 +1207,13 @@ static uint *QT_FASTCALL destFetch(uint *buffer, QRasterBuffer *rasterBuffer, in
 static QRgba64 *QT_FASTCALL destFetch64(QRgba64 *buffer, QRasterBuffer *rasterBuffer, int x, int y, int length)
 {
     const QPixelLayout *layout = &qPixelLayouts[rasterBuffer->format];
-    uint buffer32[buffer_size];
-    const uint *ptr = qFetchPixels[layout->bpp](buffer32, rasterBuffer->scanLine(y), x, length);
-    return const_cast<QRgba64 *>(layout->convertToARGB64PM(buffer, ptr, length, layout, 0));
+    const quint64 *ptr = qFetchPixels64[layout->bpp]((quint64*)buffer, rasterBuffer->scanLine(y), x, length);
+    return const_cast<QRgba64 *>(layout->convertToRGBA64PM(buffer, ptr, length, layout, 0));
 }
 
-static QRgba64 *QT_FASTCALL destFetch64uint32(QRgba64 *buffer, QRasterBuffer *rasterBuffer, int x, int y, int length)
+static QRgba64 * QT_FASTCALL destFetchRGB64(QRgba64 *, QRasterBuffer *rasterBuffer, int x, int y, int)
 {
-    const QPixelLayout *layout = &qPixelLayouts[rasterBuffer->format];
-    const uint *src = ((const uint *)rasterBuffer->scanLine(y)) + x;
-    return const_cast<QRgba64 *>(layout->convertToARGB64PM(buffer, src, length, layout, 0));
+    return (QRgba64 *)rasterBuffer->scanLine(y) + x;
 }
 
 static DestFetchProc destFetchProc[QImage::NImageFormats] =
@@ -1069,6 +1243,9 @@ static DestFetchProc destFetchProc[QImage::NImageFormats] =
     destFetch,          // Format_A2RGB30_Premultiplied
     destFetch,          // Format_Alpha8
     destFetch,          // Format_Grayscale8
+    destFetch,          // Format_RGBX64
+    destFetch,          // Format_RGBA64
+    destFetch,          // Format_RGBA64_Premultiplied
 };
 
 static DestFetchProc64 destFetchProc64[QImage::NImageFormats] =
@@ -1077,9 +1254,9 @@ static DestFetchProc64 destFetchProc64[QImage::NImageFormats] =
     destFetch64,        // Format_Mono,
     destFetch64,        // Format_MonoLSB
     0,                  // Format_Indexed8
-    destFetch64uint32,  // Format_RGB32
-    destFetch64uint32,  // Format_ARGB32,
-    destFetch64uint32,  // Format_ARGB32_Premultiplied
+    destFetch64,        // Format_RGB32
+    destFetch64,        // Format_ARGB32,
+    destFetch64,        // Format_ARGB32_Premultiplied
     destFetch64,        // Format_RGB16
     destFetch64,        // Format_ARGB8565_Premultiplied
     destFetch64,        // Format_RGB666
@@ -1089,15 +1266,18 @@ static DestFetchProc64 destFetchProc64[QImage::NImageFormats] =
     destFetch64,        // Format_RGB888
     destFetch64,        // Format_RGB444
     destFetch64,        // Format_ARGB4444_Premultiplied
-    destFetch64uint32,  // Format_RGBX8888
-    destFetch64uint32,  // Format_RGBA8888
-    destFetch64uint32,  // Format_RGBA8888_Premultiplied
-    destFetch64uint32,  // Format_BGR30
-    destFetch64uint32,  // Format_A2BGR30_Premultiplied
-    destFetch64uint32,  // Format_RGB30
-    destFetch64uint32,  // Format_A2RGB30_Premultiplied
+    destFetch64,        // Format_RGBX8888
+    destFetch64,        // Format_RGBA8888
+    destFetch64,        // Format_RGBA8888_Premultiplied
+    destFetch64,        // Format_BGR30
+    destFetch64,        // Format_A2BGR30_Premultiplied
+    destFetch64,        // Format_RGB30
+    destFetch64,        // Format_A2RGB30_Premultiplied
     destFetch64,        // Format_Alpha8
     destFetch64,        // Format_Grayscale8
+    destFetchRGB64,     // Format_RGBX64
+    destFetch64,        // Format_RGBA64
+    destFetchRGB64,     // Format_RGBA64_Premultiplied
 };
 
 /*
@@ -1216,13 +1396,6 @@ static void QT_FASTCALL destStore(QRasterBuffer *rasterBuffer, int x, int y, con
     }
 }
 
-static void QT_FASTCALL convertFromRgb64(uint *dest, const QRgba64 *src, int length)
-{
-    for (int i = 0; i < length; ++i) {
-        dest[i] = src[i].toArgb32();
-    }
-}
-
 static void QT_FASTCALL destStore64(QRasterBuffer *rasterBuffer, int x, int y, const QRgba64 *buffer, int length)
 {
     uint buf[buffer_size];
@@ -1232,7 +1405,7 @@ static void QT_FASTCALL destStore64(QRasterBuffer *rasterBuffer, int x, int y, c
     while (length) {
         int l = qMin(length, buffer_size);
         const uint *ptr = 0;
-        convertFromRgb64(buf, buffer, l);
+        qt_convertRGBA64ToARGB32<false>(buf, buffer, length);
         if (!layout->premultiplied && !layout->alphaWidth)
             ptr = layout->convertFromRGB32(buf, buf, l, layout, 0);
         else
